/**************************************************************************
 *                                                                        *
 *                       This file is part of PSReg                       *
 *                                                                        *
 *          Copyright (C) 2002 Ko Nishino. All Rights Reserved.           *
 *                                                                        *
 *  Permission to use this software for educational and research purposes *
 * is hereby granted without fee. All other rights, including the rights  *
 * to distribute, modify, or sell the software, are explicitly reserved   *
 * by the author. Please contact the author if you wish to make any       *
 * modifications or additions to the software.                            *
 *                                                                        *
 *  This software is provided "as is" and without warranty of any kind,   *
 * express, implied or otherwise, including without limitation, any       *
 * warranty of merchantability or fitness for a particular purpose.       *
 *                                                                        *
 **************************************************************************/
/*  
 *  RPoint.h
 *          Ko Nishino 
 *               kon@cvl.iis.u-tokyo.ac.jp
 *               http://www.cvl.iis.u-tokyo.ac.jp/~kon/
 */


#ifndef _RPOINT_H_
#define _RPOINT_H_

#include "Pose.h"

class CRPoint
{
public:
    CRPoint();
    virtual ~CRPoint();

    void transform(const CPose& cp);
    const gsl_vector* getCoord() const { return m_vC; }
    const gsl_vector* getNormal() const { return m_vN; }
    const float getInten() const { return m_fI; }

    void setCoord(float fX, float fY, float fZ){
	gsl_vector_set(m_vC, 0, fX);
	gsl_vector_set(m_vC, 1, fY);
	gsl_vector_set(m_vC, 2, fZ);
	gsl_vector_set(m_vC, 3, 1.0);
    }	

    void setNormal(float fX, float fY, float fZ){
	gsl_vector_set(m_vN, 0, fX);
	gsl_vector_set(m_vN, 1, fY);
	gsl_vector_set(m_vN, 2, fZ);
	gsl_vector_set(m_vN, 3, 1.0);
    }	

    void setInten(float fI){
	m_fI = fI;
    }

private:
    gsl_vector* m_vC;
    gsl_vector* m_vN;
    
    float m_pfC[3];
    float m_pfN[3];
    float m_fI;
};

#endif // _RPOINT_H_
